
import java.awt.*;
import java.io.PrintWriter;
import java.io.StringWriter;
import javax.swing.*;
import display.*;
import define.*; // Pack mit display extern definierten Objekten

/**
Demonstration der extern definierten Objekte.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class DefDemo {

 static public void main( String[] args) {
 JFrame frame = new JFrame();
 MathPanel panel = new MathPanel( null); 

  frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  frame.setTitle( "Test-Frame des Mahtematik-Displays");
  frame.getContentPane().add( panel, "Center");
  frame.setSize( 1000, 700);
  frame.show();

 Graphics2D g2d = (Graphics2D)panel.getGraphics();

  g2d.setFont( new Font( "serif", Font.PLAIN, 80));
  g2d.setRenderingHint( RenderingHints.KEY_ANTIALIASING,
                        RenderingHints.VALUE_ANTIALIAS_ON);

  DispObject.setDefaultColor( g2d.getColor());
  DispObject.setDefaultFont( g2d.getFont());
  DispObject.setDefaultRenderContext( g2d.getFontRenderContext());
  DispObject.setDefaultSpacing();

 DispRow base     = new DispRow( new DispObject[] {new DispString( "b")});
 DispRow exponent = new DispRow( new DispObject[] {new DispString( "e")});
 Exp exp = new Exp( base, exponent);

  panel.object = exp; // obj; // Objekt an Panel binden
  panel.repaint();    // Panel (mit Objekt) anzeigen.

  // textuelle Ausgabe vorbereiten und starten
  DispObject.term = new StringWriter();               // String bekommt Ausgaben
  DispObject.out = new PrintWriter( DispObject.term); // Print-Methoden bereitstellen
  DispObject.print( 0, exp);                          // Ausgabe erzeugen
 String term = DispObject.term.toString();            // Ausgabe lesen
  System.out.println( term);                          // aufgebauten String anzeigen
  DispObject.term = new StringWriter();               // bereit für neue Ausgaben
  DispObject.out = new PrintWriter( DispObject.term); // mit Print-Methoden
 }
}
