
import java.awt.*;
import javax.swing.*;
import display.*;

/**
Einfaches Panel zur Bereitstellung eines grafischen Kontextes.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class MathPanel extends JPanel {
public static final long serialVersionUID = 123; // sonst warnt eclipse

public DispObject object;

 /**
 Creator mit Bindung des anzuzeigenden Objekts.
 @param object das anzuzeigende Objekt.
 */
 public MathPanel( DispObject object) {
  this.object = object;
 }
 /**
 Überschreiben der ursprünglichen Methode zur eigenen Darstellung.
 @param g1 einfacher grafischer Kontext.
 */
 public void paintComponent( Graphics g1) {
  super.paintComponent( g1);
  if (object != null)
	  DispObject.paintAt( object, 
			              0, 
			              (Graphics2D)g1, 
			              (this.getWidth() -object.bnd.getWidth())  / 2.0, 
			              (this.getHeight()-object.bnd.getHeight()) / 2.0);
 }
}
