
import javax.xml.parsers.*;  // SAXParser
import display.*;			 // DISPlayOBJECTs
import handlers.*;			 // DokumentHandler zur Anzeige von MathML

/**
Demonstration der einfachen Interpretation von MathML-Dokumenten.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class demo02 {

 static public void main( String[] args) {
 MathPanel          panel = new MathPanel( null);     // hat grafischen Kontext
 javax.swing.JFrame frame = new javax.swing.JFrame(); // das Frame

  // einfaches Frame aufbauen und anzeigen
  frame.setDefaultCloseOperation( javax.swing.JFrame.EXIT_ON_CLOSE);
  frame.setTitle( "Test-Frame des Mahtematik-Displays");
  frame.getContentPane().add( panel, "Center");
  frame.setSize( 1000, 700);
  frame.show();

  // grafischer Kontext ist definiert. Font und Rendering setzen
 java.awt.Graphics2D g2d = (java.awt.Graphics2D)panel.getGraphics();
  g2d.setFont( new java.awt.Font( "serif", java.awt.Font.PLAIN, 80));
  g2d.setRenderingHint( java.awt.RenderingHints.KEY_ANTIALIASING,
		                java.awt.RenderingHints.VALUE_ANTIALIAS_ON);

  // Properties des/der Display-Object(s) festlegen
  DispObject.setDefaultColor( g2d.getColor());                     // Farbe setzen
  DispObject.setDefaultFont( g2d.getFont());                       // Font setzen
  DispObject.setDefaultRenderContext( g2d.getFontRenderContext()); // Panel-Kontext
  DispObject.setDefaultSpacing();								   // einfaches Spacing
  DispObject.term = new java.io.StringWriter();                    // Ausgaben in String
  DispObject.out  = new java.io.PrintWriter( DispObject.term);     // Ziel der Ausgabe

  // MathML-Handler und -Dokument festlegen
 MathDocHandler handler = new MathDocHandler();           // MathML-Handler
 java.io.File   file    = new java.io.File( "math1.xml"); // MathML-Dokument

  // Parsen des MathML-Dokuments
  try   {
        SAXParser parser = SAXParserFactory.newInstance().newSAXParser();
         parser.parse( file, handler);
        }
  catch (Throwable throwable)
        {
         throwable.printStackTrace();
         System.exit( 1);
        }
  
  // Aufbau der Anzeige mit/Ohne Anzeige des Trees
 boolean showtree = true;
  if ( showtree) System.out.println( "MathML-Tree in postorder:\n");
  handler.build( handler.tree.root, 0, showtree);

  // Anzeigeobjekt auslesen 
 DispObject obj = handler.type.result();

 // Anzeige
  panel.object = obj; // Objekt an Panel binden
  panel.repaint();    // Panel (mit Objekt) anzeigen.

  // textuelle Ausgabe vorbereiten und starten
  System.out.println( "\n\nInterne Struktur in preorder:");
  DispObject.print( 0, obj);                       // Ausgabe erzeugen
  System.out.println( DispObject.term.toString()); // Ausgabe anzeigen
 }
}
