package display;

import java.util.*;

/**
Klasse zur Bereitstellung eines geklammerten Ausdrucks.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class DispFence extends DispObject {

 /**
 Aufbau eines MathFence-Objekts.
 @param o Zeichen für öffnende Klammer. Ein Leerzeichen meint hier keine Klammer.
 @param fo zu klammerndes Objekt.
 @param c Zeichen für schliessende Klammer. Ein Leerzeichen meint hier keine Klammer.
 */
 static public void build( DispObject mr, char o, DispObject fo, char c) {
  // Liste für "mrow"-Opjekt aufbauen
 LinkedList list = new LinkedList();
  if (o != ' ')
     {
     DispObject par = new DispObject();
      // Klammer dehnen
      DispObject.characterData( par, o);
      DispObject.compress( par);
      DispObject.scale( par, fo.bnd.getHeight(), DispObject.VERTICAL);
      par.bse = fo.bse;
      list.add( par);
     }
  list.add( fo);
  if (c != ' ')
     {
     DispObject par = new DispObject();
      // Klammer dehnen
      DispObject.characterData( par, c);
      DispObject.compress( par);
      DispObject.scale( par, fo.bnd.getHeight(), DispObject.VERTICAL);
      par.bse = fo.bse;
      list.add( par);
     }
  DispRow.build( mr, list, DispObject.defaultRowSpace); // "mrow"-Objekt aufbauen
 }

 /**
 Spezifische Ausgabe für Objekte der MathFence-Klasse.
 @param deep Tiefe der Einrückung. Dient der strukturierten Ausgabe.
 @param obj Objekt für textueller Ausgabe.
 */
 static public void printSpecial( int deep, DispObject obj) {
 Iterator iter = obj.objects.iterator();
 DispObject op = null;
 DispObject ob = null;
 DispObject cl = null;
 DispObject elm = (DispObject)iter.next();

  if    (elm.shp != null)
        {
         op = elm;
         ob = (DispObject)iter.next();
        }
  else ob = elm;
  cl = (DispObject)iter.next();
  if    (op == null)
        {
         DispObject.out.println();
         for (int s=0; s<deep+1; s++) DispObject.out.print( " ");
         DispObject.out.println( "' '");
        }
  else DispObject.print( deep+1, op);
  DispObject.out.print( ",");
  DispObject.print( deep+1, ob);
  DispObject.out.print( ",");
  if    (cl == null)
        {
         DispObject.out.println();
         for (int s=0; s<deep+1; s++) DispObject.out.print( " ");
         DispObject.out.println( "' '");
        }
  else DispObject.print( deep+1, cl);
 }

 /**
 Creator eines MathFence-Objekts. Dieser "leere" Creator dient einer weiteren
 Flexibilisierung durch Trennung von Instanzierung und dem eigentlichen
 Aufbau des Objekts mit der Methode "build".
 Für die "build"-Methode von Objekten dieser Klasse müssen die
 "streching"-Operationen extern durchgeführt werden.
@see super.build.
 */
 public DispFence() {
 }

 /**
 Creator eines MathFence-Objekts.
 @param o Zeichen für öffnende Klammer. Ein Leerzeichen meint hier keine Klammer.
 @param fo zu klammerndes Objekt.
 @param c Zeichen für schliessende Klammer. Ein Leerzeichen meint hier keine Klammer.
 */
 public DispFence( char o, DispObject fo, char c) {
  build( this, o, fo, c);
 }
}
