package display;

import java.util.*;
import java.awt.geom.*;

/**
Klasse zum unter- und überschreiben eines Ausdrucks.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class DispUnderover extends DispObject {

 /**
 Aufbau eines MathUnderover-Objekts.
 @param opo Container für beteiligte MathObjekte.
 @param op Objekt mit Über- und/oder Untertext.
 @param from Objekt für Unterschrift.
 @param to Objekt für Überschrift.
 */
 static public void build( DispObject opo, DispObject op, DispObject from, DispObject to) {
  // Liste der Objekte aufbauen
//  if (to != null) DispObject.resize( to, DispObject.supScale);
  DispObject.append( opo, to);
  DispObject.append( opo, op);
//  if (from != null) DispObject.resize( from, DispObject.subScale);
  DispObject.append( opo, from);
 // Alignment
 Rectangle2D[] tupel = new Rectangle2D[opo.objects.size()];
 Iterator      iter  = opo.objects.iterator();
  for (int i = 0; i < tupel.length; i++)
       tupel[i] = ((DispObject)iter.next()).bnd;
  tupel = Align.alignCol( tupel, Align.CENTER, 0);
  // Bounds ermitteln
  DispObject.bounds( opo, tupel);
  // Baseline festlegen
 opo.bse = op.bse + op.bnd.getY();
 }

 /**
 Spezifische Ausgabe für Objekte der MathUnderover-Klasse.
 @param deep Tiefe der Einrückung. Dient der strukturierten Ausgabe.
 @param obj Objekt für textueller Ausgabe.
 */
 static public void printSpecial( int deep, DispObject obj) {
 Iterator   iter = obj.objects.iterator();
 DispObject elm  = (DispObject)iter.next();

  DispObject.print( deep+1, (DispObject)iter.next());
  DispObject.out.print( ",");
  DispObject.print( deep+1, (DispObject)iter.next());
  DispObject.out.print( ",");
  DispObject.print( deep+1, elm);
 }

 /**
 Creator eines MathUnderover-Objekts.
 @param op Objekt mit Über- und/oder Untertext.
 @param from Objekt für Unterschrift.
 @param to Objekt für Überschrift.
 */
 public DispUnderover( DispObject op, DispObject from, DispObject to) {
  build( this, op, from, to);
 }
}
