
package lists;

/**
Klasse einer Objektliste mit gleichzeitiger Eigenschaft List und Stack.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class List{
public Item first = null;
public Item last  = null;

 /**
 Anzahl der Elemente in der Liste ermitteln.
 @param list Zu untersuchende Liste.
 @return Anzahl der Elemente.
 */
 static public int length( List list) {
 int  len = 0;
 Item itm = list.first;

  while (itm != null)
         {
          len++;
          itm = itm.next;
         }
  return len;
 }

 /**
 Neuen Eintrag ans Ende der Liste setzen.
 @param list Zu erweiternde Liste.
 @param item Neuer Eintrag.
 */
 static public void append( List list, Item item) {
  if (list.last == null)
     {
      list.last  = item;
      list.first = item;
      return;
     }
  list.last.next = item;
  list.last      = list.last.next;
 }

/**
 Neuen Eintrag an den Anfang der Liste setzen.
 @param list Zu erweiternde Liste.
 @param item Neuer Eintrag.
 */
 static public void push( List list, Item item) {
  item.next = list.first;
  list.first = item;
  if (list.last == null) list.last = list.first;
 }

 /**
 Eintrag vom Anfang der Liste entfernen und ausgeben.
 @param list Betroffene Liste.
 @return Eintrag aus der Liste.
 */
 static public Item pop( List list) {
 Item item = list.first;

  list.first = item.next;
  item.next = null;
  return item;
 }

 /**
 Bestimmtes (iniziertes) Element der Liste ausgeben.
 @param list Liste mit indiziertem Element.
 @param ord Ordinalzahl (Index) des Elements.
 @return indiziertes Element.
 */
 static public Item get( List list, long ord) {
 Item item = list.first;
 long i    = 0;

 while (i<ord)
        {
         item = item.next;
         i++;
        }
  return item;
 }
}
